"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tsParticles = void 0;
const engine_1 = require("./engine");
const HslColorManager_1 = require("./Utils/HslColorManager");
const RgbColorManager_1 = require("./Utils/RgbColorManager");
const ColorUtils_1 = require("./Utils/ColorUtils");
const rgbColorManager = new RgbColorManager_1.RgbColorManager(), hslColorManager = new HslColorManager_1.HslColorManager();
(0, ColorUtils_1.addColorManager)("rgb", rgbColorManager);
(0, ColorUtils_1.addColorManager)("hsl", hslColorManager);
const tsParticles = new engine_1.Engine();
exports.tsParticles = tsParticles;
tsParticles.init();
__exportStar(require("./Core/Utils/Circle"), exports);
__exportStar(require("./Core/Utils/CircleWarp"), exports);
__exportStar(require("./Core/Utils/Constants"), exports);
__exportStar(require("./Core/Utils/ExternalInteractorBase"), exports);
__exportStar(require("./Core/Utils/ParticlesInteractorBase"), exports);
__exportStar(require("./Core/Utils/Point"), exports);
__exportStar(require("./Core/Utils/Range"), exports);
__exportStar(require("./Core/Utils/Rectangle"), exports);
__exportStar(require("./Core/Utils/Vector"), exports);
__exportStar(require("./Core/Utils/Vector3d"), exports);
__exportStar(require("./Enums/Directions/MoveDirection"), exports);
__exportStar(require("./Enums/Directions/RotateDirection"), exports);
__exportStar(require("./Enums/Directions/OutModeDirection"), exports);
__exportStar(require("./Enums/Modes/ClickMode"), exports);
__exportStar(require("./Enums/Modes/DestroyMode"), exports);
__exportStar(require("./Enums/Modes/DivMode"), exports);
__exportStar(require("./Enums/Modes/HoverMode"), exports);
__exportStar(require("./Enums/Modes/CollisionMode"), exports);
__exportStar(require("./Enums/Modes/OutMode"), exports);
__exportStar(require("./Enums/Modes/SizeMode"), exports);
__exportStar(require("./Enums/Modes/ThemeMode"), exports);
__exportStar(require("./Enums/Modes/ResponsiveMode"), exports);
__exportStar(require("./Enums/Types/AlterType"), exports);
__exportStar(require("./Enums/Types/DestroyType"), exports);
__exportStar(require("./Enums/Types/GradientType"), exports);
__exportStar(require("./Enums/Types/InteractorType"), exports);
__exportStar(require("./Enums/Types/ParticleOutType"), exports);
__exportStar(require("./Enums/Types/StartValueType"), exports);
__exportStar(require("./Enums/Types/DivType"), exports);
__exportStar(require("./Enums/Types/EasingType"), exports);
__exportStar(require("./Enums/AnimationStatus"), exports);
__exportStar(require("./Enums/InteractivityDetect"), exports);
__exportStar(require("./Options/Classes/AnimatableColor"), exports);
__exportStar(require("./Options/Classes/AnimationOptions"), exports);
__exportStar(require("./Options/Classes/Background/Background"), exports);
__exportStar(require("./Options/Classes/BackgroundMask/BackgroundMask"), exports);
__exportStar(require("./Options/Classes/BackgroundMask/BackgroundMaskCover"), exports);
__exportStar(require("./Options/Classes/ColorAnimation"), exports);
__exportStar(require("./Options/Classes/FullScreen/FullScreen"), exports);
__exportStar(require("./Options/Classes/HslAnimation"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/ClickEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/DivEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/ClickEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/DivEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/Events"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/HoverEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/Parallax"), exports);
__exportStar(require("./Options/Classes/Interactivity/Interactivity"), exports);
__exportStar(require("./Options/Classes/Interactivity/Modes/Modes"), exports);
__exportStar(require("./Options/Classes/Interactivity/Modes/Slow"), exports);
__exportStar(require("./Options/Classes/ManualParticle"), exports);
__exportStar(require("./Options/Classes/Motion/Motion"), exports);
__exportStar(require("./Options/Classes/Motion/MotionReduce"), exports);
__exportStar(require("./Options/Classes/Options"), exports);
__exportStar(require("./Options/Classes/OptionsColor"), exports);
__exportStar(require("./Options/Classes/Particles/Bounce/ParticlesBounce"), exports);
__exportStar(require("./Options/Classes/Particles/Bounce/ParticlesBounceFactor"), exports);
__exportStar(require("./Options/Classes/Particles/Collisions/Collisions"), exports);
__exportStar(require("./Options/Classes/Particles/Collisions/CollisionsOverlap"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/Destroy"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/Split"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/SplitFactor"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/SplitRate"), exports);
__exportStar(require("./Options/Classes/Particles/ParticlesOptions"), exports);
__exportStar(require("./Options/Classes/Particles/Shadow"), exports);
__exportStar(require("./Options/Classes/Particles/Stroke"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveAttract"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Move"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveAngle"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveGravity"), exports);
__exportStar(require("./Options/Classes/Particles/Move/OutModes"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Path/MovePath"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Path/MovePathDelay"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Spin"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveTrail"), exports);
__exportStar(require("./Options/Classes/Particles/Number/ParticlesNumber"), exports);
__exportStar(require("./Options/Classes/Particles/Number/ParticlesDensity"), exports);
__exportStar(require("./Options/Classes/Particles/Opacity/Opacity"), exports);
__exportStar(require("./Options/Classes/Particles/Opacity/OpacityAnimation"), exports);
__exportStar(require("./Options/Classes/Particles/Rotate/Rotate"), exports);
__exportStar(require("./Options/Classes/Particles/Rotate/RotateAnimation"), exports);
__exportStar(require("./Options/Classes/Particles/Shape/Shape"), exports);
__exportStar(require("./Options/Classes/Particles/Size/Size"), exports);
__exportStar(require("./Options/Classes/Particles/Size/SizeAnimation"), exports);
__exportStar(require("./Options/Classes/Particles/ZIndex/ZIndex"), exports);
__exportStar(require("./Options/Classes/Responsive"), exports);
__exportStar(require("./Options/Classes/Theme/Theme"), exports);
__exportStar(require("./Options/Classes/Theme/ThemeDefault"), exports);
__exportStar(require("./Options/Classes/ValueWithRandom"), exports);
__exportStar(require("./Utils/CanvasUtils"), exports);
__exportStar(require("./Utils/ColorUtils"), exports);
__exportStar(require("./Utils/HslColorManager"), exports);
__exportStar(require("./Utils/NumberUtils"), exports);
__exportStar(require("./Utils/OptionsUtils"), exports);
__exportStar(require("./Utils/RgbColorManager"), exports);
__exportStar(require("./Utils/Utils"), exports);
