"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tsParticles = void 0;
const engine_1 = require("./engine");
const HslColorManager_1 = require("./Utils/HslColorManager");
const RgbColorManager_1 = require("./Utils/RgbColorManager");
const ColorUtils_1 = require("./Utils/ColorUtils");
const rgbColorManager = new RgbColorManager_1.RgbColorManager(), hslColorManager = new HslColorManager_1.HslColorManager();
(0, ColorUtils_1.addColorManager)("rgb", rgbColorManager);
(0, ColorUtils_1.addColorManager)("hsl", hslColorManager);
const tsParticles = new engine_1.Engine();
exports.tsParticles = tsParticles;
tsParticles.init();
__exportStar(require("./Core/Interfaces/Colors"), exports);
__exportStar(require("./Core/Interfaces/IBounds"), exports);
__exportStar(require("./Core/Interfaces/IBubbleParticleData"), exports);
__exportStar(require("./Core/Interfaces/ICircleBouncer"), exports);
__exportStar(require("./Core/Interfaces/IColorManager"), exports);
__exportStar(require("./Core/Interfaces/IContainerInteractivity"), exports);
__exportStar(require("./Core/Interfaces/IContainerPlugin"), exports);
__exportStar(require("./Core/Interfaces/ICoordinates"), exports);
__exportStar(require("./Core/Interfaces/IDelta"), exports);
__exportStar(require("./Core/Interfaces/IDimension"), exports);
__exportStar(require("./Core/Interfaces/IDistance"), exports);
__exportStar(require("./Core/Interfaces/IExternalInteractor"), exports);
__exportStar(require("./Core/Interfaces/IInteractor"), exports);
__exportStar(require("./Core/Interfaces/IMouseData"), exports);
__exportStar(require("./Core/Interfaces/IMovePathGenerator"), exports);
__exportStar(require("./Core/Interfaces/IParticle"), exports);
__exportStar(require("./Core/Interfaces/IParticleColorStyle"), exports);
__exportStar(require("./Core/Interfaces/IParticleHslAnimation"), exports);
__exportStar(require("./Core/Interfaces/IParticlesInteractor"), exports);
__exportStar(require("./Core/Interfaces/IParticleLife"), exports);
__exportStar(require("./Core/Interfaces/IParticleRetinaProps"), exports);
__exportStar(require("./Core/Interfaces/IParticleRoll"), exports);
__exportStar(require("./Core/Interfaces/IParticleUpdater"), exports);
__exportStar(require("./Core/Interfaces/IParticleValueAnimation"), exports);
__exportStar(require("./Core/Interfaces/IParticleWobble"), exports);
__exportStar(require("./Core/Interfaces/IParticlesMover"), exports);
__exportStar(require("./Core/Interfaces/IPlugin"), exports);
__exportStar(require("./Core/Interfaces/IRangeValue"), exports);
__exportStar(require("./Core/Interfaces/IRectSideResult"), exports);
__exportStar(require("./Core/Interfaces/IShapeDrawer"), exports);
__exportStar(require("./Core/Interfaces/IShapeValues"), exports);
__exportStar(require("./Core/Utils/Circle"), exports);
__exportStar(require("./Core/Utils/CircleWarp"), exports);
__exportStar(require("./Core/Utils/Constants"), exports);
__exportStar(require("./Core/Utils/ExternalInteractorBase"), exports);
__exportStar(require("./Core/Utils/ParticlesInteractorBase"), exports);
__exportStar(require("./Core/Utils/Point"), exports);
__exportStar(require("./Core/Utils/Range"), exports);
__exportStar(require("./Core/Utils/Rectangle"), exports);
__exportStar(require("./Core/Utils/Vector"), exports);
__exportStar(require("./Core/Utils/Vector3d"), exports);
__exportStar(require("./Enums/Directions/MoveDirection"), exports);
__exportStar(require("./Enums/Directions/RotateDirection"), exports);
__exportStar(require("./Enums/Directions/OutModeDirection"), exports);
__exportStar(require("./Enums/Modes/ClickMode"), exports);
__exportStar(require("./Enums/Modes/DestroyMode"), exports);
__exportStar(require("./Enums/Modes/DivMode"), exports);
__exportStar(require("./Enums/Modes/HoverMode"), exports);
__exportStar(require("./Enums/Modes/CollisionMode"), exports);
__exportStar(require("./Enums/Modes/OutMode"), exports);
__exportStar(require("./Enums/Modes/SizeMode"), exports);
__exportStar(require("./Enums/Modes/ThemeMode"), exports);
__exportStar(require("./Enums/Modes/ResponsiveMode"), exports);
__exportStar(require("./Enums/Types/AlterType"), exports);
__exportStar(require("./Enums/Types/DestroyType"), exports);
__exportStar(require("./Enums/Types/GradientType"), exports);
__exportStar(require("./Enums/Types/InteractorType"), exports);
__exportStar(require("./Enums/Types/ParticleOutType"), exports);
__exportStar(require("./Enums/Types/StartValueType"), exports);
__exportStar(require("./Enums/Types/DivType"), exports);
__exportStar(require("./Enums/Types/EasingType"), exports);
__exportStar(require("./Enums/AnimationStatus"), exports);
__exportStar(require("./Enums/InteractivityDetect"), exports);
__exportStar(require("./Options/Classes/AnimatableColor"), exports);
__exportStar(require("./Options/Classes/AnimationOptions"), exports);
__exportStar(require("./Options/Classes/Background/Background"), exports);
__exportStar(require("./Options/Classes/BackgroundMask/BackgroundMask"), exports);
__exportStar(require("./Options/Classes/BackgroundMask/BackgroundMaskCover"), exports);
__exportStar(require("./Options/Classes/ColorAnimation"), exports);
__exportStar(require("./Options/Classes/FullScreen/FullScreen"), exports);
__exportStar(require("./Options/Classes/HslAnimation"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/ClickEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/DivEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/ClickEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/DivEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/Events"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/HoverEvent"), exports);
__exportStar(require("./Options/Classes/Interactivity/Events/Parallax"), exports);
__exportStar(require("./Options/Classes/Interactivity/Interactivity"), exports);
__exportStar(require("./Options/Classes/Interactivity/Modes/Modes"), exports);
__exportStar(require("./Options/Classes/Interactivity/Modes/Slow"), exports);
__exportStar(require("./Options/Classes/ManualParticle"), exports);
__exportStar(require("./Options/Classes/Motion/Motion"), exports);
__exportStar(require("./Options/Classes/Motion/MotionReduce"), exports);
__exportStar(require("./Options/Classes/Options"), exports);
__exportStar(require("./Options/Classes/OptionsColor"), exports);
__exportStar(require("./Options/Classes/Particles/Bounce/ParticlesBounce"), exports);
__exportStar(require("./Options/Classes/Particles/Bounce/ParticlesBounceFactor"), exports);
__exportStar(require("./Options/Classes/Particles/Collisions/Collisions"), exports);
__exportStar(require("./Options/Classes/Particles/Collisions/CollisionsOverlap"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/Destroy"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/Split"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/SplitFactor"), exports);
__exportStar(require("./Options/Classes/Particles/Destroy/SplitRate"), exports);
__exportStar(require("./Options/Classes/Particles/ParticlesOptions"), exports);
__exportStar(require("./Options/Classes/Particles/Shadow"), exports);
__exportStar(require("./Options/Classes/Particles/Stroke"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveAttract"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Move"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveAngle"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveGravity"), exports);
__exportStar(require("./Options/Classes/Particles/Move/OutModes"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Path/MovePath"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Path/MovePathDelay"), exports);
__exportStar(require("./Options/Classes/Particles/Move/Spin"), exports);
__exportStar(require("./Options/Classes/Particles/Move/MoveTrail"), exports);
__exportStar(require("./Options/Classes/Particles/Number/ParticlesNumber"), exports);
__exportStar(require("./Options/Classes/Particles/Number/ParticlesDensity"), exports);
__exportStar(require("./Options/Classes/Particles/Opacity/Opacity"), exports);
__exportStar(require("./Options/Classes/Particles/Opacity/OpacityAnimation"), exports);
__exportStar(require("./Options/Classes/Particles/Rotate/Rotate"), exports);
__exportStar(require("./Options/Classes/Particles/Rotate/RotateAnimation"), exports);
__exportStar(require("./Options/Classes/Particles/Shape/Shape"), exports);
__exportStar(require("./Options/Classes/Particles/Size/Size"), exports);
__exportStar(require("./Options/Classes/Particles/Size/SizeAnimation"), exports);
__exportStar(require("./Options/Classes/Particles/ZIndex/ZIndex"), exports);
__exportStar(require("./Options/Classes/Responsive"), exports);
__exportStar(require("./Options/Classes/Theme/Theme"), exports);
__exportStar(require("./Options/Classes/Theme/ThemeDefault"), exports);
__exportStar(require("./Options/Classes/ValueWithRandom"), exports);
__exportStar(require("./Options/Interfaces/Background/IBackground"), exports);
__exportStar(require("./Options/Interfaces/BackgroundMask/IBackgroundMask"), exports);
__exportStar(require("./Options/Interfaces/BackgroundMask/IBackgroundMaskCover"), exports);
__exportStar(require("./Options/Interfaces/FullScreen/IFullScreen"), exports);
__exportStar(require("./Options/Interfaces/IAnimatable"), exports);
__exportStar(require("./Options/Interfaces/IAnimatableColor"), exports);
__exportStar(require("./Options/Interfaces/IAnimation"), exports);
__exportStar(require("./Options/Interfaces/IColorAnimation"), exports);
__exportStar(require("./Options/Interfaces/IHslAnimation"), exports);
__exportStar(require("./Options/Interfaces/IManualParticle"), exports);
__exportStar(require("./Options/Interfaces/IOptionLoader"), exports);
__exportStar(require("./Options/Interfaces/IOptions"), exports);
__exportStar(require("./Options/Interfaces/IOptionsColor"), exports);
__exportStar(require("./Options/Interfaces/IResponsive"), exports);
__exportStar(require("./Options/Interfaces/IValueWithRandom"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Events/IClickEvent"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Events/IDivEvent"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Events/IEvents"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Events/IHoverEvent"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Events/IParallax"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Modes/IModeDiv"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Modes/IModes"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/Modes/ISlow"), exports);
__exportStar(require("./Options/Interfaces/Interactivity/IInteractivity"), exports);
__exportStar(require("./Options/Interfaces/Motion/IMotion"), exports);
__exportStar(require("./Options/Interfaces/Motion/IMotionReduce"), exports);
__exportStar(require("./Options/Interfaces/Particles/Bounce/IParticlesBounce"), exports);
__exportStar(require("./Options/Interfaces/Particles/Collisions/ICollisions"), exports);
__exportStar(require("./Options/Interfaces/Particles/Collisions/ICollisionsOverlap"), exports);
__exportStar(require("./Options/Interfaces/Particles/Destroy/IDestroy"), exports);
__exportStar(require("./Options/Interfaces/Particles/Destroy/ISplit"), exports);
__exportStar(require("./Options/Interfaces/Particles/IParticlesOptions"), exports);
__exportStar(require("./Options/Interfaces/Particles/IShadow"), exports);
__exportStar(require("./Options/Interfaces/Particles/IStroke"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/IMoveAttract"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/IMove"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/IMoveAngle"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/IMoveGravity"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/Path/IMovePath"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/IOutModes"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/ISpin"), exports);
__exportStar(require("./Options/Interfaces/Particles/Move/IMoveTrail"), exports);
__exportStar(require("./Options/Interfaces/Particles/Number/IParticlesDensity"), exports);
__exportStar(require("./Options/Interfaces/Particles/Number/IParticlesNumber"), exports);
__exportStar(require("./Options/Interfaces/Particles/Opacity/IOpacity"), exports);
__exportStar(require("./Options/Interfaces/Particles/Opacity/IOpacityAnimation"), exports);
__exportStar(require("./Options/Interfaces/Particles/Rotate/IRotate"), exports);
__exportStar(require("./Options/Interfaces/Particles/Rotate/IRotateAnimation"), exports);
__exportStar(require("./Options/Interfaces/Particles/Shape/ICharacterShape"), exports);
__exportStar(require("./Options/Interfaces/Particles/Shape/IImageShape"), exports);
__exportStar(require("./Options/Interfaces/Particles/Shape/IPolygonShape"), exports);
__exportStar(require("./Options/Interfaces/Particles/Shape/IShape"), exports);
__exportStar(require("./Options/Interfaces/Particles/Shape/IShapeValues"), exports);
__exportStar(require("./Options/Interfaces/Particles/Shape/IStarShape"), exports);
__exportStar(require("./Options/Interfaces/Particles/Size/ISize"), exports);
__exportStar(require("./Options/Interfaces/Particles/Size/ISizeAnimation"), exports);
__exportStar(require("./Options/Interfaces/Particles/ZIndex/IZIndex"), exports);
__exportStar(require("./Options/Interfaces/Theme/ITheme"), exports);
__exportStar(require("./Options/Interfaces/Theme/IThemeDefault"), exports);
__exportStar(require("./Types/RangeValue"), exports);
__exportStar(require("./Types/RecursivePartial"), exports);
__exportStar(require("./Types/ShapeData"), exports);
__exportStar(require("./Types/ShapeDrawerFunctions"), exports);
__exportStar(require("./Types/SingleOrMultiple"), exports);
__exportStar(require("./Types/PathOptions"), exports);
__exportStar(require("./Utils/CanvasUtils"), exports);
__exportStar(require("./Utils/ColorUtils"), exports);
__exportStar(require("./Utils/HslColorManager"), exports);
__exportStar(require("./Utils/NumberUtils"), exports);
__exportStar(require("./Utils/OptionsUtils"), exports);
__exportStar(require("./Utils/RgbColorManager"), exports);
__exportStar(require("./Utils/Utils"), exports);
