import type { Container } from "./Container";
import type { IContainerPlugin } from "./Interfaces/IContainerPlugin";
import type { IDelta } from "./Interfaces/IDelta";
import type { IDimension } from "./Interfaces/IDimension";
import type { Particle } from "./Particle";
export declare class Canvas {
    #private;
    private readonly container;
    element?: HTMLCanvasElement;
    resizeFactor?: IDimension;
    readonly size: IDimension;
    private coverColorStyle?;
    private generatedCanvas;
    private originalStyle?;
    private trailFillColor?;
    constructor(container: Container);
    clear(): void;
    destroy(): void;
    draw<T>(cb: (context: CanvasRenderingContext2D) => T): T | undefined;
    drawParticle(particle: Particle, delta: IDelta): void;
    drawParticlePlugin(plugin: IContainerPlugin, particle: Particle, delta: IDelta): void;
    drawPlugin(plugin: IContainerPlugin, delta: IDelta): void;
    init(): void;
    initBackground(): void;
    initPlugins(): void;
    initUpdaters(): void;
    loadCanvas(canvas: HTMLCanvasElement): void;
    paint(): void;
    resize(): void;
    windowResize(): Promise<void>;
    private applyPostDrawUpdaters;
    private applyPreDrawUpdaters;
    private applyResizePlugins;
    private getPluginParticleColors;
    private initCover;
    private initStyle;
    private initTrail;
    private paintBase;
    private resetOriginalStyle;
}
