import { AnimatableColor } from "../AnimatableColor";
import { Collisions } from "./Collisions/Collisions";
import type { Container } from "../../../Core/Container";
import { Destroy } from "./Destroy/Destroy";
import type { Engine } from "../../../engine";
import type { IInteractivity } from "../../Interfaces/Interactivity/IInteractivity";
import type { IOptionLoader } from "../../Interfaces/IOptionLoader";
import type { IParticlesOptions } from "../../Interfaces/Particles/IParticlesOptions";
import { Move } from "./Move/Move";
import { Opacity } from "./Opacity/Opacity";
import { ParticlesBounce } from "./Bounce/ParticlesBounce";
import type { ParticlesGroups } from "../../../Types/ParticlesGroups";
import { ParticlesNumber } from "./Number/ParticlesNumber";
import type { RecursivePartial } from "../../../Types/RecursivePartial";
import { Rotate } from "./Rotate/Rotate";
import { Shadow } from "./Shadow";
import { Shape } from "./Shape/Shape";
import type { SingleOrMultiple } from "../../../Types/SingleOrMultiple";
import { Size } from "./Size/Size";
import { Stroke } from "./Stroke";
import { ZIndex } from "./ZIndex/ZIndex";
export declare class ParticlesOptions implements IParticlesOptions, IOptionLoader<IParticlesOptions> {
    #private;
    [name: string]: unknown;
    bounce: ParticlesBounce;
    collisions: Collisions;
    color: AnimatableColor;
    destroy: Destroy;
    groups: ParticlesGroups;
    interactivity?: RecursivePartial<IInteractivity>;
    move: Move;
    number: ParticlesNumber;
    opacity: Opacity;
    reduceDuplicates: boolean;
    rotate: Rotate;
    shadow: Shadow;
    shape: Shape;
    size: Size;
    stroke: SingleOrMultiple<Stroke>;
    zIndex: ZIndex;
    constructor(engine: Engine, container?: Container);
    load(data?: RecursivePartial<IParticlesOptions>): void;
}
