var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    var _InteractionManager_engine, _InteractionManager_interactors;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.InteractionManager = void 0;
    class InteractionManager {
        constructor(engine, container) {
            this.container = container;
            _InteractionManager_engine.set(this, void 0);
            _InteractionManager_interactors.set(this, void 0);
            __classPrivateFieldSet(this, _InteractionManager_engine, engine, "f");
            __classPrivateFieldSet(this, _InteractionManager_interactors, __classPrivateFieldGet(this, _InteractionManager_engine, "f").plugins.getInteractors(this.container, true), "f");
            this.externalInteractors = [];
            this.particleInteractors = [];
        }
        async externalInteract(delta) {
            for (const interactor of this.externalInteractors) {
                if (interactor.isEnabled()) {
                    await interactor.interact(delta);
                }
            }
        }
        handleClickMode(mode) {
            for (const interactor of this.externalInteractors) {
                if (interactor.handleClickMode) {
                    interactor.handleClickMode(mode);
                }
            }
        }
        init() {
            this.externalInteractors = [];
            this.particleInteractors = [];
            for (const interactor of __classPrivateFieldGet(this, _InteractionManager_interactors, "f")) {
                switch (interactor.type) {
                    case 0:
                        this.externalInteractors.push(interactor);
                        break;
                    case 1:
                        this.particleInteractors.push(interactor);
                        break;
                }
                interactor.init();
            }
        }
        async particlesInteract(particle, delta) {
            for (const interactor of this.externalInteractors) {
                interactor.clear(particle);
            }
            for (const interactor of this.particleInteractors) {
                if (interactor.isEnabled(particle)) {
                    await interactor.interact(particle, delta);
                }
            }
        }
        async reset(particle) {
            for (const interactor of this.externalInteractors) {
                if (interactor.isEnabled()) {
                    await interactor.reset(particle);
                }
            }
            for (const interactor of this.particleInteractors) {
                if (interactor.isEnabled(particle)) {
                    await interactor.reset(particle);
                }
            }
        }
    }
    exports.InteractionManager = InteractionManager;
    _InteractionManager_engine = new WeakMap(), _InteractionManager_interactors = new WeakMap();
});
